"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var binder_base_1 = require("./binder-base");
var value_converter_1 = require("./value-converter");
var DecoratorBinder = /** @class */ (function (_super) {
    tslib_1.__extends(DecoratorBinder, _super);
    function DecoratorBinder() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DecoratorBinder.prototype.bind = function (routeInfo, parameterName, request) {
        var decorators = routeInfo.methodMetaData.parameters.filter(function (x) { return x.name == parameterName; })[0].decorators;
        if (!decorators)
            return this.next();
        var decorator = decorators.filter(function (x) { return x.name == "body" || x.name == "cookie"; })[0];
        if (!decorator)
            return this.next();
        if (decorator.name == "cookie") {
            var value = value_converter_1.convert(routeInfo, parameterName, this.extractCookie(request, decorator));
            return this.exit(value);
        }
        else {
            return this.exit(request.body);
        }
    };
    DecoratorBinder.prototype.extractCookie = function (request, decorator) {
        if (!decorator.parameters || decorator.parameters.length == 0) {
            return request.cookies;
        }
        else {
            var name_1 = decorator.parameters[0].value;
            return request.getCookie(name_1);
        }
    };
    return DecoratorBinder;
}(binder_base_1.BinderBase));
exports.DecoratorBinder = DecoratorBinder;
