"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var api_convention_binder_1 = require("./api-convention-binder");
var decorator_binder_1 = require("./decorator-binder");
var default_binder_1 = require("./default-binder");
var val_type_binder_1 = require("./val-type-binder");
var ParameterBinder = /** @class */ (function () {
    function ParameterBinder(routeInfo, pathResolver) {
        this.routeInfo = routeInfo;
        this.pathResolver = pathResolver;
        this.commands = [];
        //priorities
        this.commands = [
            new decorator_binder_1.DecoratorBinder(),
            new api_convention_binder_1.ApiConventionBinder(),
            new val_type_binder_1.ValTypeBinder(this.pathResolver),
            new default_binder_1.DefaultBinder()
        ];
    }
    ParameterBinder.prototype.getParameters = function (context) {
        if (!this.routeInfo.methodMetaData.parameters ||
            this.routeInfo.methodMetaData.parameters.length == 0)
            return [];
        var result = [];
        for (var _i = 0, _a = this.routeInfo.methodMetaData.parameters; _i < _a.length; _i++) {
            var par = _a[_i];
            result.push(this.bind(par.name, context));
        }
        return result;
    };
    ParameterBinder.prototype.bind = function (parameterName, request) {
        for (var _i = 0, _a = this.commands; _i < _a.length; _i++) {
            var cmd = _a[_i];
            var result = cmd.bind(this.routeInfo, parameterName, request);
            if (result.type == "Exit")
                return result.value;
        }
    };
    return ParameterBinder;
}());
exports.ParameterBinder = ParameterBinder;
