"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var binder_base_1 = require("./binder-base");
var resolver_1 = require("../resolver");
var ValTypeBinder = /** @class */ (function (_super) {
    tslib_1.__extends(ValTypeBinder, _super);
    function ValTypeBinder(pathResolver) {
        var _this = _super.call(this) || this;
        _this.pathResolver = pathResolver;
        return _this;
    }
    ValTypeBinder.prototype.bind = function (routeInfo, parameterName, request) {
        if (routeInfo.methodMetaData.parameters.some(function (x) { return x.decorators != undefined
            && x.decorators.some(function (d) { return d.name == "body"; }); }))
            return this.next();
        var decorators = routeInfo.methodMetaData
            .parameters.filter(function (x) { return x.name == parameterName; })[0].decorators;
        if (decorators == undefined || decorators.length == 0 || !decorators.some(function (x) { return x.name == "type"; }))
            return this.next();
        var typeDecorator = decorators.filter(function (x) { return x.name == "type"; })[0].parameters[0];
        if (!new resolver_1.QualifiedName(typeDecorator.value, this.pathResolver).isValid())
            return this.next();
        return this.exit(request.body);
    };
    return ValTypeBinder;
}(binder_base_1.BinderBase));
exports.ValTypeBinder = ValTypeBinder;
