"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var base_converter_1 = require("./base-converter");
var router_1 = require("../../router");
var ConventionValueConverter = /** @class */ (function (_super) {
    tslib_1.__extends(ConventionValueConverter, _super);
    function ConventionValueConverter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ConventionValueConverter.prototype.convert = function (meta, value) {
        if (typeof value == "undefined" || value == null)
            return this.exit(value);
        if (meta.name.indexOf("s") == 0 && this.isUppercase(meta.name[1]))
            return this.toString(value, meta);
        if ((meta.name.indexOf("i") == 0 || meta.name.indexOf("n") == 0) &&
            this.isUppercase(meta.name[1]))
            return this.toNumber(value, meta);
        if (meta.name.indexOf("b") == 0 && this.isUppercase(meta.name[1]))
            return this.toBoolean(value, meta);
        return this.next();
    };
    ConventionValueConverter.prototype.isUppercase = function (char) {
        return char && char == char.toUpperCase();
    };
    ConventionValueConverter.prototype.toString = function (value, meta) {
        if (typeof value == "object")
            throw new Error("Expected parameter type of 'string'  but got object in [" + meta.name + "] " + router_1.getRouteDetail(this.routeInfo));
        return this.exit(value.toString());
    };
    ConventionValueConverter.prototype.toNumber = function (value, meta) {
        if (typeof value == "object")
            throw new Error("Expected parameter type of 'number'  but got object in [" + meta.name + "] " + router_1.getRouteDetail(this.routeInfo));
        return this.exit(parseInt(value));
    };
    ConventionValueConverter.prototype.toBoolean = function (value, meta) {
        if (typeof value == "object")
            throw new Error("Expected parameter type of 'boolean'  but got object in [" + meta.name + "] " + router_1.getRouteDetail(this.routeInfo));
        return this.exit(value.toLowerCase() === "true");
    };
    return ConventionValueConverter;
}(base_converter_1.BaseConverter));
exports.ConventionValueConverter = ConventionValueConverter;
