"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var decorated_value_converter_1 = require("./decorated-value-converter");
var default_value_converter_1 = require("./default-value-converter");
var convention_value_converter_1 = require("./convention-value-converter");
function convert(routeInfo, name, value) {
    var Converters = [
        new decorated_value_converter_1.DecoratedValueConverter(routeInfo),
        new convention_value_converter_1.ConventionValueConverter(routeInfo),
        new default_value_converter_1.DefaultValueConverter(routeInfo)
    ];
    for (var _i = 0, Converters_1 = Converters; _i < Converters_1.length; _i++) {
        var converter = Converters_1[_i];
        var result = converter.convert(routeInfo.methodMetaData.parameters.filter(function (x) { return x.name == name; })[0], value);
        if (result.type == "Exit")
            return result.result;
    }
}
exports.convert = convert;
tslib_1.__exportStar(require("./auto-converter"), exports);
