"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var framework_1 = require("../../framework");
var MiddlewareFactory;
(function (MiddlewareFactory) {
    function resolveArray(middlewares, resolver) {
        var result = [];
        if (!middlewares)
            return result;
        for (var _i = 0, middlewares_1 = middlewares; _i < middlewares_1.length; _i++) {
            var middleware = middlewares_1[_i];
            var mdw = resolve(middleware, resolver);
            result.push(mdw);
        }
        return result;
    }
    MiddlewareFactory.resolveArray = resolveArray;
    function resolve(middleware, resolver) {
        if (typeof middleware == "string") {
            try {
                return resolver.resolve(middleware);
            }
            catch (e) {
                throw new Error("Can not instantiate middleware [" + middleware + "]");
            }
        }
        else if (typeof middleware == "function") {
            return new framework_1.CallbackMiddleware(middleware);
        }
        else {
            return middleware;
        }
    }
    MiddlewareFactory.resolve = resolve;
})(MiddlewareFactory = exports.MiddlewareFactory || (exports.MiddlewareFactory = {}));
