"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Chalk = require("chalk");
var Logger = /** @class */ (function () {
    function Logger(type) {
        this.type = type;
    }
    Logger.prototype.log = function (type, message) {
        var chalk;
        var prefix = "";
        switch (type) {
            case "Error":
                prefix = "Error: ";
                chalk = Chalk.red;
                break;
            case "Warning":
                prefix = "Warning: ";
                chalk = Chalk.yellow;
                break;
            default:
                chalk = function (msg) { return msg; };
                break;
        }
        console.log(chalk(Chalk.bold("  [Kamboja] ")) + chalk(prefix + message));
        return this;
    };
    Logger.prototype.info = function (message) {
        if (this.type == "Info")
            return this.log("Info", message);
        else
            return this;
    };
    Logger.prototype.error = function (message) {
        if (this.type == "Info" || this.type == "Warning" || this.type == "Error")
            return this.log("Error", message);
        else
            return this;
    };
    Logger.prototype.warning = function (message) {
        if (this.type == "Info" || this.type == "Warning")
            return this.log("Warning", message);
        else
            return this;
    };
    Logger.prototype.newLine = function () {
        if (this.type == "Info" || this.type == "Warning" || this.type == "Error")
            console.log();
        return this;
    };
    return Logger;
}());
exports.Logger = Logger;
