"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Path = require("path");
var DefaultPathResolver = /** @class */ (function () {
    function DefaultPathResolver(rootPath) {
        this.rootPath = rootPath;
    }
    /**
     * Resolve path from relative to absolute
     */
    DefaultPathResolver.prototype.resolve = function (path) {
        return Path.join(this.rootPath, path);
    };
    /**
     * Convert absolute path to relative to this.rootPath
     */
    DefaultPathResolver.prototype.relative = function (absolute) {
        return Path.relative(this.rootPath, absolute);
    };
    /**
     * Normalize path to qualified name path
     */
    DefaultPathResolver.prototype.normalize = function (path) {
        if (Path.isAbsolute(path)) {
            path = this.relative(path);
        }
        var raw = Path.parse(path);
        return Path.join(raw.dir, raw.name);
    };
    return DefaultPathResolver;
}());
exports.DefaultPathResolver = DefaultPathResolver;
