"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var QualifiedName = /** @class */ (function () {
    function QualifiedName(qualifiedName, pathResolver) {
        this.qualifiedName = qualifiedName;
        this.pathResolver = pathResolver;
        var tokens = this.qualifiedName.split(",");
        if (tokens.length != 2) {
            this.valid = false;
        }
        else {
            this.valid = true;
            this.className = tokens[0].trim();
            this.array = this.className.indexOf("[]", this.className.length - 2) != -1;
            if (this.array) {
                this.className = this.className.substr(0, this.className.length - 2);
            }
            var fileRaw = tokens[1].trim();
            this.fileName = pathResolver.normalize(fileRaw);
            this.qualifiedName = this.className + ", " + this.fileName;
        }
    }
    QualifiedName.prototype.isValid = function () {
        return this.valid;
    };
    QualifiedName.prototype.equals = function (qualifiedName) {
        var qualified;
        if (typeof qualifiedName == "string")
            qualified = new QualifiedName(qualifiedName, this.pathResolver);
        else
            qualified = qualifiedName;
        return this.className === qualified.className
            && this.fileName === qualified.fileName;
    };
    QualifiedName.prototype.isArray = function () {
        return this.array;
    };
    return QualifiedName;
}());
exports.QualifiedName = QualifiedName;
