"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var kamboja_core_1 = require("kamboja-core");
var ClassNotInherritedFromControllerAnalyzer = /** @class */ (function () {
    function ClassNotInherritedFromControllerAnalyzer() {
    }
    ClassNotInherritedFromControllerAnalyzer.prototype.analyse = function (route) {
        if (route.analysis
            && route.analysis.some(function (x) { return x == kamboja_core_1.RouteAnalysisCode.ClassNotInheritedFromController; })
            && route.classMetaData
            && route.classMetaData.name.toLowerCase().endsWith("controller")) {
            return [{
                    code: kamboja_core_1.RouteAnalysisCode.ClassNotInheritedFromController,
                    type: "Warning",
                    message: "Class not inherited from Controller, ApiController in [" + route.qualifiedClassName + "]"
                }];
        }
    };
    return ClassNotInherritedFromControllerAnalyzer;
}());
exports.ClassNotInherritedFromControllerAnalyzer = ClassNotInherritedFromControllerAnalyzer;
