"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var kamboja_core_1 = require("kamboja-core");
var helper_1 = require("../helper");
var DuplicateRouteAnalyzer = /** @class */ (function () {
    function DuplicateRouteAnalyzer() {
        this.routes = [];
    }
    DuplicateRouteAnalyzer.prototype.analyse = function (route) {
        if (!route.route)
            return;
        var dupe = this.routes.filter(function (x) { return x.route.toLowerCase() == route.route.toLowerCase()
            && route.httpMethod == x.httpMethod; });
        if (dupe.length > 0) {
            return [{
                    code: kamboja_core_1.RouteAnalysisCode.DuplicateRoutes,
                    message: "Duplicate route [" + route.route + "] on: \n  " + helper_1.getRouteDetail(route) + " \n  " + helper_1.getRouteDetail(dupe[0]),
                    type: "Error"
                }];
        }
        else {
            this.routes.push(route);
            return;
        }
    };
    return DuplicateRouteAnalyzer;
}());
exports.DuplicateRouteAnalyzer = DuplicateRouteAnalyzer;
