"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var kamboja_core_1 = require("kamboja-core");
var helper_1 = require("../helper");
var EventWithQueryParameters = /** @class */ (function () {
    function EventWithQueryParameters() {
        this.routes = [];
    }
    EventWithQueryParameters.prototype.analyse = function (route) {
        if (route.analysis && route.analysis.some(function (x) { return x == kamboja_core_1.RouteAnalysisCode.QueryParameterNotAllowed; })) {
            var routeParams = route.route.split("/")
                .filter(function (x) { return x.charAt(0) == ":"; })
                .map(function (x) { return x.substring(1); });
            return [{
                    code: kamboja_core_1.RouteAnalysisCode.QueryParameterNotAllowed,
                    type: "Error",
                    message: "Query parameters in @route.on() is not allowed in " + helper_1.getRouteDetail(route)
                }];
        }
    };
    return EventWithQueryParameters;
}());
exports.EventWithQueryParameters = EventWithQueryParameters;
