"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var kamboja_core_1 = require("kamboja-core");
var helper_1 = require("../helper");
var MissingActionParameterAnalyzer = /** @class */ (function () {
    function MissingActionParameterAnalyzer() {
    }
    MissingActionParameterAnalyzer.prototype.analyse = function (route) {
        if (route.analysis && route.analysis.some(function (x) { return x == kamboja_core_1.RouteAnalysisCode.MissingActionParameters; })) {
            var routeParams = route.route.split("/")
                .filter(function (x) { return x.charAt(0) == ":"; })
                .map(function (x) { return x.substring(1); });
            return [{
                    code: kamboja_core_1.RouteAnalysisCode.MissingActionParameters,
                    type: "Warning",
                    message: "Parameters [" + routeParams.join(", ") + "] in [" + route.route + "] doesn't have associated parameters in " + helper_1.getRouteDetail(route)
                }];
        }
    };
    return MissingActionParameterAnalyzer;
}());
exports.MissingActionParameterAnalyzer = MissingActionParameterAnalyzer;
