"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var kamboja_core_1 = require("kamboja-core");
var helper_1 = require("../helper");
var MissingRouteParameterAnalyzer = /** @class */ (function () {
    function MissingRouteParameterAnalyzer() {
    }
    MissingRouteParameterAnalyzer.prototype.analyse = function (route) {
        if (route.analysis && route.analysis.some(function (x) { return x == kamboja_core_1.RouteAnalysisCode.MissingRouteParameters; })) {
            var actionParams = route.methodMetaData
                .parameters.map(function (x) { return x.name; });
            return [{
                    code: kamboja_core_1.RouteAnalysisCode.MissingRouteParameters,
                    type: "Warning",
                    message: "Parameters [" + actionParams.join(", ") + "] in " + helper_1.getRouteDetail(route) + " doesn't have associated parameters in [" + route.route + "]"
                }];
        }
    };
    return MissingRouteParameterAnalyzer;
}());
exports.MissingRouteParameterAnalyzer = MissingRouteParameterAnalyzer;
