"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var kamboja_core_1 = require("kamboja-core");
var helper_1 = require("../helper");
var UnassociatedParameterAnalyzer = /** @class */ (function () {
    function UnassociatedParameterAnalyzer() {
    }
    UnassociatedParameterAnalyzer.prototype.analyse = function (route) {
        if (route.analysis && route.analysis.some(function (x) { return x == kamboja_core_1.RouteAnalysisCode.UnAssociatedParameters; })) {
            var routeParams_1 = route.route.split("/")
                .filter(function (x) { return x.charAt(0) == ":"; })
                .map(function (x) { return x.substring(1); });
            var actionParams = route.methodMetaData
                .parameters.map(function (x) { return x.name; });
            var missing = actionParams.filter(function (x) { return !routeParams_1.some(function (y) { return x == y; }); });
            if (missing.length > 0) {
                return [{
                        code: kamboja_core_1.RouteAnalysisCode.UnAssociatedParameters,
                        type: "Warning",
                        message: "Parameters [" + missing.join(", ") + "] in " + helper_1.getRouteDetail(route) + " doesn't have associated parameters in [" + route.route + "]"
                    }];
            }
        }
    };
    return UnassociatedParameterAnalyzer;
}());
exports.UnassociatedParameterAnalyzer = UnassociatedParameterAnalyzer;
