"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var kamboja_core_1 = require("kamboja-core");
var helper_1 = require("../helper");
var reservedWords = [
    "context", "validator"
];
var apiReservedWords = [
    "context", "validator"
];
var ReservedWordUsedAnalyzer = /** @class */ (function () {
    function ReservedWordUsedAnalyzer() {
    }
    ReservedWordUsedAnalyzer.prototype.analyse = function (route) {
        var usedInController = reservedWords.some(function (x) { return route.methodMetaData
            && x == route.methodMetaData.name; })
            && route.classMetaData.baseClass == "Controller";
        var usedInApiController = apiReservedWords.some(function (x) { return route.methodMetaData
            && x == route.methodMetaData.name; })
            && route.classMetaData.baseClass == "ApiController";
        if (usedInApiController || usedInController) {
            return [{
                    code: kamboja_core_1.RouteAnalysisCode.UnAssociatedParameters,
                    type: "Error",
                    message: "[" + route.methodMetaData.name + "] must not be used as action, because it will override the Controller method, in " + helper_1.getRouteDetail(route)
                }];
        }
    };
    return ReservedWordUsedAnalyzer;
}());
exports.ReservedWordUsedAnalyzer = ReservedWordUsedAnalyzer;
