"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Transformer = require("./transformers");
var RouteGenerator = /** @class */ (function () {
    function RouteGenerator(idResolver, metaData) {
        this.idResolver = idResolver;
        this.metaData = metaData;
    }
    RouteGenerator.prototype.getRoutes = function () {
        var _this = this;
        var routes = [];
        for (var _i = 0, _a = this.metaData; _i < _a.length; _i++) {
            var file = _a[_i];
            var route = Transformer.transform(file);
            route.forEach(function (x) {
                x.classId = _this.idResolver.getClassId(x.qualifiedClassName);
                routes.push(x);
            });
        }
        return routes;
    };
    return RouteGenerator;
}());
exports.RouteGenerator = RouteGenerator;
