"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var Kecubung = require("kecubung");
var Core = require("kamboja-core");
var transformer_base_1 = require("./transformer-base");
var DefaultActionTransformer = /** @class */ (function (_super) {
    tslib_1.__extends(DefaultActionTransformer, _super);
    function DefaultActionTransformer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DefaultActionTransformer.prototype.transform = function (method, parent, prevResult) {
        var path = "/" + method.name.toLowerCase();
        /* method.parameters.forEach(x => {
            path += `/:${x.name}`
        }) */
        if (prevResult) {
            prevResult.forEach(function (x) {
                if (Kecubung.flag(x.overrideRequest, Core.OverrideRequest.Route)) {
                    x.route = parent + path;
                    x.methodPath = path;
                }
                x.collaborator = [];
                x.collaborator.push("DefaultAction");
            });
            return this.exit(prevResult);
        }
        else {
            return this.exit([{
                    initiator: "DefaultAction",
                    route: parent + path,
                    httpMethod: "GET",
                    methodMetaData: method,
                    methodPath: path
                }]);
        }
    };
    tslib_1.__decorate([
        transformer_base_1.when("Method")
    ], DefaultActionTransformer.prototype, "transform", null);
    return DefaultActionTransformer;
}(transformer_base_1.TransformerBase));
exports.DefaultActionTransformer = DefaultActionTransformer;
