"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var transformer_base_1 = require("./transformer-base");
var controller_1 = require("./controller");
var module_1 = require("./module");
var controller_decorator_1 = require("./controller-decorator");
var FileTransformer = /** @class */ (function (_super) {
    tslib_1.__extends(FileTransformer, _super);
    function FileTransformer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FileTransformer.prototype.transform = function (meta, parent, prevResult) {
        this.installChildTransformer();
        var result = this.transformChildren(meta.children, parent);
        result.forEach(function (x) { return x.qualifiedClassName += ", " + meta.name; });
        return this.exit(result);
    };
    FileTransformer.prototype.installChildTransformer = function () {
        //highest priority transformer should stay on top of another
        this.transformers = [
            new module_1.ModuleTransformer(),
            new controller_decorator_1.ControllerWithDecorator(),
            new controller_1.ControllerTransformer(),
        ];
    };
    tslib_1.__decorate([
        transformer_base_1.when("File")
    ], FileTransformer.prototype, "transform", null);
    return FileTransformer;
}(transformer_base_1.TransformerBase));
exports.FileTransformer = FileTransformer;
