"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var transformer_base_1 = require("./transformer-base");
var IndexActionTransformer = /** @class */ (function (_super) {
    tslib_1.__extends(IndexActionTransformer, _super);
    function IndexActionTransformer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    IndexActionTransformer.prototype.transform = function (method, parent, prevResult) {
        if (prevResult)
            return this.next(prevResult);
        if (method.name.toLowerCase() == "index") {
            method.parameters.forEach(function (x) {
                parent += "/:" + x.name;
            });
            return this.exit([{
                    initiator: "IndexAction",
                    route: parent,
                    httpMethod: "GET",
                    methodMetaData: method
                }]);
        }
        else
            return this.next();
    };
    tslib_1.__decorate([
        transformer_base_1.when("Method")
    ], IndexActionTransformer.prototype, "transform", null);
    return IndexActionTransformer;
}(transformer_base_1.TransformerBase));
exports.IndexActionTransformer = IndexActionTransformer;
