"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var Core = require("kamboja-core");
var transformer_base_1 = require("./transformer-base");
var InternalDecoratorTransformer = /** @class */ (function (_super) {
    tslib_1.__extends(InternalDecoratorTransformer, _super);
    function InternalDecoratorTransformer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.decorators = ["get", "put", "post", "delete", "ignore", "patch"];
        return _this;
    }
    InternalDecoratorTransformer.prototype.transform = function (meta, parent, prevResult) {
        var _this = this;
        if (meta.decorators && meta.decorators.length > 0) {
            var decorators = meta.decorators.filter(function (x) { return _this.decorators.some(function (y) { return y == x.name; }); });
            //decorator conflict with internal
            if ((decorators.some(function (x) { return x.name == "ignore"; })
                && decorators.length > 1)) {
                return this.next({
                    analysis: [Core.RouteAnalysisCode.ConflictDecorators],
                    methodMetaData: meta,
                    httpMethod: "GET",
                    initiator: "InternalDecorator"
                });
            }
            for (var _i = 0, _a = meta.decorators; _i < _a.length; _i++) {
                var decorator = _a[_i];
                var name_1 = decorator.name;
                if (name_1 == "ignore")
                    return this.exit();
            }
        }
        return this.next();
    };
    tslib_1.__decorate([
        transformer_base_1.when("Method")
    ], InternalDecoratorTransformer.prototype, "transform", null);
    return InternalDecoratorTransformer;
}(transformer_base_1.TransformerBase));
exports.InternalDecoratorTransformer = InternalDecoratorTransformer;
