"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var Kecubung = require("kecubung");
var Core = require("kamboja-core");
var transformer_base_1 = require("./transformer-base");
var controller_decorator_1 = require("./controller-decorator");
var controller_1 = require("./controller");
var ModuleTransformer = /** @class */ (function (_super) {
    tslib_1.__extends(ModuleTransformer, _super);
    function ModuleTransformer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ModuleTransformer.prototype.transform = function (meta, parent, prevResult) {
        this.installChildTransformer();
        parent += "/" + meta.name.toLowerCase();
        var result = this.transformChildren(meta.children, parent);
        result.forEach(function (x) {
            if (!Kecubung.flag(meta.analysis, Kecubung.AnalysisType.Valid)) {
                if (!x.analysis)
                    x.analysis = [];
                x.analysis.push(Core.RouteAnalysisCode.ClassNotExported);
            }
            x.qualifiedClassName = meta.name + "." + x.qualifiedClassName;
            if (!x.collaborator)
                x.collaborator = [];
            x.collaborator.push("Module");
        });
        return this.exit(result);
    };
    ModuleTransformer.prototype.installChildTransformer = function () {
        //highest priority transformer should stay on top of another
        this.transformers = [
            new ModuleTransformer(),
            new controller_decorator_1.ControllerWithDecorator(),
            new controller_1.ControllerTransformer(),
        ];
    };
    tslib_1.__decorate([
        transformer_base_1.when("Module")
    ], ModuleTransformer.prototype, "transform", null);
    return ModuleTransformer;
}(transformer_base_1.TransformerBase));
exports.ModuleTransformer = ModuleTransformer;
