"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var META_DATA_KEY = "kamboja:Call.when";
function when(kind) {
    return function (target, method, descriptor) {
        Reflect.defineMetadata(META_DATA_KEY, kind, target, method);
    };
}
exports.when = when;
function getWhen(target, methodName) {
    return Reflect.getMetadata(META_DATA_KEY, target, methodName);
}
exports.getWhen = getWhen;
var TransformerBase = /** @class */ (function () {
    function TransformerBase() {
    }
    TransformerBase.prototype.transformChildren = function (children, parent) {
        var result = [];
        var lastResult;
        var _loop_1 = function (child) {
            var trans = this_1.transformers.filter(function (x) { return getWhen(x, "transform") == child.type; });
            for (var _i = 0, trans_1 = trans; _i < trans_1.length; _i++) {
                var transformer = trans_1[_i];
                var tempResult = transformer.transform(child, parent, lastResult ? lastResult.info : undefined);
                var exit = false;
                switch (tempResult.status) {
                    case "ExitWithResult":
                        result = result.concat(tempResult.info);
                        exit = true;
                        break;
                    case "Next":
                        lastResult = tempResult;
                        break;
                    case "Exit":
                        exit = true;
                        break;
                }
                if (exit)
                    break;
            }
        };
        var this_1 = this;
        for (var _i = 0, children_1 = children; _i < children_1.length; _i++) {
            var child = children_1[_i];
            _loop_1(child);
        }
        return result;
    };
    TransformerBase.prototype.next = function (result) {
        if (result)
            return {
                status: "Next",
                info: Array.isArray(result) ? result : [result]
            };
        else
            return { status: "Next" };
    };
    TransformerBase.prototype.exit = function (result) {
        if (result)
            return {
                status: "ExitWithResult",
                info: Array.isArray(result) ? result : [result]
            };
        return { status: "Exit" };
    };
    return TransformerBase;
}());
exports.TransformerBase = TransformerBase;
