import 'reflect-metadata';
import * as Kecubung from "kecubung";
import { ValidationError, FieldValidatorArg, ValidatorCommand } from "kamboja-core";
export declare function decoratorName(decoratorName: string): (target: any, propertyKey: string, index: any) => void;
export declare function getDecoratorName(target: any): string;
export interface ParametersValidatorArg {
    type: "ParametersValidator";
    parameterValues: any[];
    parentField?: string;
    methodName: string;
    classInfo: Kecubung.ClassMetaData;
}
export interface PropertiesValidatorArg {
    type: "PropertiesValidator";
    classInstance: any;
    parentField?: string;
    classInfo: Kecubung.ClassMetaData;
    isArray: boolean;
}
export declare class ValidatorBase implements ValidatorCommand {
    validators: ValidatorCommand[];
    validate(args: FieldValidatorArg): ValidationError[] | undefined;
    isEmpty(value: any): boolean;
    protected validateFields(arg: ParametersValidatorArg | PropertiesValidatorArg): ValidationError[] | undefined;
    private useValidators(arg);
}
