"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var baseclasses_1 = require("./baseclasses");
var Validator = require("validator");
var EmailValidator = /** @class */ (function (_super) {
    tslib_1.__extends(EmailValidator, _super);
    function EmailValidator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    EmailValidator.prototype.validate = function (args) {
        if (this.isEmpty(args.value))
            return;
        if (!Validator.isEmail(args.value.toString())) {
            var argument = args.decoratorArgs[0];
            var customMessage = argument && argument.value;
            return [{
                    field: args.parentField ? args.parentField + "." + args.field : args.field,
                    message: customMessage || "[" + args.field + "] is not a valid email address"
                }];
        }
    };
    tslib_1.__decorate([
        baseclasses_1.decoratorName("email")
    ], EmailValidator.prototype, "validate", null);
    return EmailValidator;
}(baseclasses_1.ValidatorBase));
exports.EmailValidator = EmailValidator;
