"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var baseclasses_1 = require("./baseclasses");
var RequiredValidator = /** @class */ (function (_super) {
    tslib_1.__extends(RequiredValidator, _super);
    function RequiredValidator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RequiredValidator.prototype.validate = function (args) {
        if (this.isEmpty(args.value)) {
            var decoratorArg = args.decoratorArgs[0];
            var customMessage = decoratorArg && decoratorArg.value;
            return [{
                    field: args.parentField ? args.parentField + "." + args.field : args.field,
                    message: customMessage || "[" + args.field + "] is required"
                }];
        }
    };
    tslib_1.__decorate([
        baseclasses_1.decoratorName("required")
    ], RequiredValidator.prototype, "validate", null);
    return RequiredValidator;
}(baseclasses_1.ValidatorBase));
exports.RequiredValidator = RequiredValidator;
