"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ValidatorFactory;
(function (ValidatorFactory) {
    function resolve(commands, resolver) {
        var validators = [];
        commands.forEach(function (x) {
            if (typeof x == "string") {
                try {
                    var validator_1 = resolver.resolve(x);
                    validators.push(validator_1);
                }
                catch (e) {
                    throw new Error("Can not instantiate custom validator [" + x + "]");
                }
            }
            else
                validators.push(x);
        });
        return validators;
    }
    ValidatorFactory.resolve = resolve;
})(ValidatorFactory = exports.ValidatorFactory || (exports.ValidatorFactory = {}));
